#include "StdAfx.h"
#include "WASListBuddy.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"


CWASListBuddy::CWASListBuddy(CWASActor *pActor) : 
	CWASCommand(pActor), m_bAllRecvedList(false), m_strLangCode(NULL), m_nCacheSerial(0)
{
}


CWASListBuddy::~CWASListBuddy(void)
{
}


void CWASListBuddy::ExecuteAsync()
{
	m_listAddressPrivate.clear();
	m_listAddress.clear();

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/buddy/ListBuddy.php");

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_strLangCode));

    // My Mobile AddressBook Cache Serial
	char szBuf[10] = {0, };
	sprintf(szBuf, "%d", m_nCacheSerial);
	m_httpFacade.session().AddBodyVariable("cacheserial", (LPCSTR)szBuf);	

    if(m_nCacheSerial <= 0)
        m_bAllRecvedList = true;
    else
        m_bAllRecvedList = false;
    
	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}


bool CWASListBuddy::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;

    CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
    ASSERT_IF_FAIL_RETURN_VALUE(pMessengerActor, false);
    
    CProfileImageActor *pProfileImageActor = static_cast<CProfileImageActor *>(pMessengerActor->GetProfileImageActor());
    ASSERT_IF_FAIL_RETURN_VALUE(pProfileImageActor, false);

	nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("nodes");
	if (pNode == NULL)
	{
		m_strWasErrMsg += _T("can not find \"<nodes>\" in addr list.");
		return false;
	}

	nfc::IIkXMLNodeList *pList = pNode->selectNodes("node");	
	nfc::IIkXMLAttribute* pAttr;
	USES_UTF8_CONVERSION;

	m_listAddressPrivate.clear();

	for (int i = 0; i < pList->Getlength(); i++)
	{	
		P_GT_BUDDY_DATA sAddrPrivate;// Ź  ʱȭ
        sAddrPrivate.Clear();
		pNode = pList->Getitem(i);
		GT_ASSERT(pNode);

		//sAddrPrivate.nID = atoi(pAttr->Gettext().c_str());
		sAddrPrivate.SetID(::rand());

		if (NULL != (pAttr = pNode->getAttribute("buddyid")))
			sAddrPrivate.SetUserID(U82W(pAttr->Gettext().c_str()));

		if (NULL != (pAttr = pNode->getAttribute("grpid")))
			sAddrPrivate.SetGroupID(atoi(pAttr->Gettext().c_str()));

		if (NULL != (pAttr = pNode->getAttribute("buddyname")))
			sAddrPrivate.SetName(U82W(pAttr->Gettext().c_str()));

		if (NULL != (pAttr = pNode->getAttribute("buddynickname")))
			sAddrPrivate.SetTalkName(U82W(pAttr->Gettext().c_str()));

		m_listAddressPrivate.push_back(sAddrPrivate);
	}

	return true;
}


// override in drived class
void CWASListBuddy::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int /*nHttpResponseCode*/, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	// WSTRING LPCWSTR ȯؼ 迭  ־!!!
	for(size_t i = 0; i < m_listAddressPrivate.size(); i++)
	{
		GT_BUDDY_DATA sTemp;
		m_listAddressPrivate[i].Convert(sTemp);
		m_listAddress.push_back(sTemp);
	}

    GT_BUDDY_DATA_LIST sList;
	sList.nSize = m_listAddress.size();
	sList.pList = sList.nSize > 0 ? &m_listAddress[0] : NULL;
	
	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseBuddyList(m_pActor, GetID(), m_eError, m_bAllRecvedList, sList) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASListBuddy::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	// WSTRING LPCWSTR ȯؼ 迭  ־!!!
	for(size_t i = 0; i < m_listAddressPrivate.size(); i++)
	{
		GT_BUDDY_DATA sTemp;
		m_listAddressPrivate[i].Convert(sTemp);
		m_listAddress.push_back(sTemp);
	}

	GT_BUDDY_DATA_LIST sList;
	sList.nSize = m_listAddress.size();
	sList.pList = sList.nSize > 0 ? &m_listAddress[0] : NULL;
	
	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseBuddyList(m_pActor, GetID(), m_eError, m_bAllRecvedList, sList) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
